require "cut_scene_common"
require "game_common"
require "lang_str"

function sequence_add(sequence, add_seq)
  for i, v in ipairs(add_seq) do
    table.insert(sequence, v)
  end
end

function start()

  game.InkIn(true)
  cut_scene.StopBgm(0)
  game.PrepareModeBgm()
  WaitTime(0.5)

  game.PlayModeBgm()
  WaitTime(1)
  sword_opening_title("media/break/title.png", LS_C_BREAK_0, 130, -40)

  local can_skip = game.IsGameComplete()

  local sequence = {}

  -- skip 1st cutscene if in demo
  if not game.IsDemo() then
    sequence_add(sequence, {

      { img = "media/break/01.png",
        move = { from = { 0, 0 }, to = { 20, 0 } },
        scale = { from = 1, to = 1.1 }
      },
      { translate_id = LS_BREAK_1, x = -50, y = 0 },
      { translate_id = LS_BREAK_2, x = -50, y = 0 }

    })
  end

  sequence_add(sequence, {

    { img = "media/break/02.png",
      scale = { from = 1.15, to = 1 }
    },
    { translate_id = LS_BREAK_3, x = 0, y = 70 },
    { translate_id = LS_BREAK_4, x = 0, y = 70 },

    { img = "media/break/03.png",
      move = { from = { 0, 0 }, to = { -20, 0 } },
      scale = { from = 1, to = 1.1 }
    },
    { translate_id = LS_BREAK_5, x = -100, y = 90 },
    { translate_id = LS_BREAK_6, x = -100, y = 90 }

  })

  sword_opening(sequence, can_skip)

  --
  finish()
end

function finish()
  game.PopState()
end

function skip()
  finish()
end
