require "cut_scene_common"
require "game_common"
require "lang_str"

can_leave = false
is_leaving = false

function txt_transition()
  TransparentTo(txt, 255, 1, false)

  -- WaitTimeAndClick(2.5)
  WaitTime(1.5)
  WaitTimeAndClick(2.5 - 1.5)

  TransparentTo(txt, 0, 0.5, false)

  -- WaitTimeAndClick(0.5)
  WaitTime(0.5)
end

function start()

  bg = SpawnSprite("media/common/bg6.png", 568, 384, 0, 0, 10)
  fg = SpawnSprite("media/none/01.png", 568, 384, -20, 0, 10.1)
  cut_scene.ObjSetColor(bg, { 255, 255, 255, 0 })
  cut_scene.ObjSetColor(fg, { 255, 255, 255, 0 })
  TransparentTo(bg, 255, 0.2, false)
  TransparentTo(fg, 255, 0.2, false)

  WaitTime(0.5)

  local complete_difficulty = game.CompleteDifficulty()
  local translate_id_1 = LS_RESTART_EASY_1
  local translate_id_2 = LS_RESTART_EASY_2
  local translate_id_3 = LS_RESTART_1

  -- test usage
  -- complete_difficulty = DIFFICULTY_NORMAL

  if DIFFICULTY_NORMAL == complete_difficulty then
    translate_id_1 = LS_RESTART_NORMAL_1
    translate_id_2 = LS_RESTART_NORMAL_2
    translate_id_3 = LS_RESTART_1
  elseif DIFFICULTY_HARD == complete_difficulty then
    translate_id_1 = LS_RESTART_HARD_1
    translate_id_2 = LS_RESTART_HARD_2
    translate_id_3 = LS_RESTART_2
  end

  local txt_x = 115

  txt = SpawnTxt(lang.GetLangStr(translate_id_1), DEFAULT_FONT, DEFAULT_FONT_SIZE, txt_x, -10, 20)
  cut_scene.ObjSetColor(txt, { 0, 0, 0, 0 })

  txt_transition()

  cut_scene.TxtSetMsg(txt, lang.GetLangStr(translate_id_2))

  txt_transition()

  cut_scene.TxtSetMsg(txt, lang.GetLangStr(translate_id_3))
  cut_scene.ObjSetPos(txt, txt_x, 0, 20)

  TransparentTo(txt, 255, 1, false)

  confirm_yes = SpawnTxt(lang.GetLangStr(LS_YES), DEFAULT_FONT, DEFAULT_FONT_SIZE, txt_x - 35, -60, 12, true, "yes")
  cut_scene.ObjSetAreaBorder(confirm_yes, 15, 15)
  cut_scene.ObjSetColor(confirm_yes, { 0, 0, 0, 0 })

  confirm_no = SpawnTxt(lang.GetLangStr(LS_NO), DEFAULT_FONT, DEFAULT_FONT_SIZE, txt_x + 35, -60, 12, true, "no")
  cut_scene.ObjSetAreaBorder(confirm_no, 15, 15)
  cut_scene.ObjSetColor(confirm_no, { 0, 0, 0, 0 })

  TransparentTo(confirm_yes, 255, 1, false)
  TransparentTo(confirm_no, 255, 1, false)
  WaitTime(1)

  can_leave = true

end

function on_yes()
  is_leaving = true
  
  game.InkIn()
  cut_scene.StopBgm(1.5)
  WaitTime(1.5)

  game.ClearInComplete()
  game.Restart(true)
end

function on_no()
  on_close()
end

function on_close()
  is_leaving = true

  TransparentTo(bg, 0, 0.2, false)
  TransparentTo(fg, 0, 0.2, false)

  ColorTo(txt, { 0, 0, 0, 0 }, 0.2, false)
  ColorTo(confirm_yes, { 0, 0, 0, 0 }, 0.2, false)
  ColorTo(confirm_no, { 0, 0, 0, 0 }, 0.2, false)

  WaitTime(0.3)

  game.PopState()
end
