BLEND_NORMAL      = 0
BLEND_ADD         = 1
BLEND_MULTIPLY    = 2
BLEND_MULTIPLY2X  = 3
BLEND_REPLACE     = 4

function SpawnSprite(material, width, height, x, y, z, name, rotate)
  if nil == z then z = 0 end
  if nil == name then name = "" end
  if nil == rotate then rotate = 0 end
  return cut_scene.SpawnSprite(scene, material, width, height, x, y, z, name, rotate)
end

function SpawnSpriteAtlas(material, setting, unit_name, scale, x, y, z, name, rotate)
  if nil == z then z = 0 end
  if nil == name then name = "" end
  if nil == rotate then rotate = 0 end
  return cut_scene.SpawnSpriteAtlas(scene, material, setting, unit_name, scale, x, y, z, name, rotate)
end

function SpawnTxt(msg, font_name, font_size, x, y, z, align_center, name)
  if nil == z then z = 0 end
  if nil == align_center then align_center = true end
  if nil == name then name = "" end
  return cut_scene.SpawnTxt(scene, msg, font_name, font_size, x, y, z, align_center, name)
end

function SpawnParticleSystem(script, material, x, y, z, name)
  if nil == z then z = 0 end
  if nil == name then name = "" end
  return cut_scene.SpawnParticleSystem(scene, script, material, x, y, z, name)
end

function SpawnChar(width, height, material, atlas, name)
  if nil == name then name = "" end
  return cut_scene.SpawnCharacter(scene, width, height, material, atlas, name)
end

function SpawnCharAutoSize(material, atlas, name)
  if nil == name then name = "" end
  return cut_scene.SpawnCharacterAutoSize(scene, material, atlas, name)
end

function CharAnim(character, name, loop, wait_finish, interval)
  if nil == loop then loop = true end
  if nil == wait_finish then wait_finish = false end
  if nil == interval then interval = 0.1 end
  local need_time = cut_scene.CharacterAnim(scene, character, name, loop, wait_finish, interval)
  if need_time and wait_finish then
    coroutine.yield()
  end
end

function WaitTime(time)
  cut_scene.WaitTime(scene, time)
  coroutine.yield()
end

function WaitTimeAndClick(time)
  cut_scene.WaitTimeAndClick(scene, time)
  return coroutine.yield()
end

function WaitClick()
  cut_scene.WaitClick(scene)
  coroutine.yield()
end

function ColorTo(obj, color, period, wait, curve)
  if nil == wait then wait = true end
  if nil == curve then curve = 0 end
  cut_scene.ObjColorTo(obj, color, period, curve)
  if wait then WaitTime(period) end
end

function TransparentTo(obj, transparent, period, wait, curve)
  if nil == wait then wait = true end
  if nil == curve then curve = 0 end
  cut_scene.ObjTransparentTo(obj, transparent, period, curve)
  if wait then WaitTime(period) end
end

function MoveTo(obj, x, y, z, period, wait, curve)
  if nil == wait then wait = true end
  if nil == curve then curve = 0 end
  cut_scene.ObjMoveTo(obj, x, y, z, period, curve)
  if wait then WaitTime(period) end
end

function ScaleTo(obj, x, y, period, wait, curve)
  if nil == wait then wait = true end
  if nil == curve then curve = 0 end
  cut_scene.ObjScaleTo(obj, x, y, period, curve)
  if wait then WaitTime(period) end
end
