require "cut_scene_common"
require "game_common"
require "lang_str"

function show_page(img_res, img_x, img_y, str_id, str_x, str_y, str_size_offset, wait_click_period)
  if nil == str_size_offset then
    str_size_offset = 0
  end

  if nil == wait_click_period then
    wait_click_period = 4
  end

  local img = SpawnSprite(img_res, 568, 384, img_x, img_y, 11)
  --local txt = SpawnTxt(lang.GetLangStr(LS_CREDITS_01), DEFAULT_FONT, DEFAULT_FONT_SIZE, 80, 40, 12)
  local txt = SpawnTxt(lang.GetLangStr(str_id), DEFAULT_FONT, DEFAULT_FONT_SIZE + str_size_offset, str_x, str_y, 12)
  cut_scene.ObjSetColor(img, { 255, 255, 255, 0 })
  cut_scene.ObjSetColor(txt, { 255, 255, 255, 0 })
  -- show
  TransparentTo(img, 255, 0.1, false)
  --TransparentTo(txt, 255, 0.1, false)
  ColorTo(txt, {255, 255, 255, 255}, 0.1, false)
  WaitTime(1)
  WaitTimeAndClick(wait_click_period)
  -- hide
  TransparentTo(img, 0, 0.2, false)
  --TransparentTo(txt, 0, 0.2, false)
  ColorTo(txt, {0, 0, 0, 0}, 0.2, false)
  WaitTime(0.2)
  -- cleanup
  cut_scene.ObjRemove(scene, img)
  cut_scene.ObjRemove(scene, txt)
end

function white_mask_in()
  local white_mask = SpawnSprite("", 568, 384, 0, 0, 12)
  cut_scene.ObjSetColor(white_mask, { 255, 255, 255, 0 })
  TransparentTo(white_mask, 255, 3, true)
end

function start()

  game.InkIn(true)
  cut_scene.StopBgm(0)
  cut_scene.PrepareBgm("media/audio/bgm/credits.caf")
  WaitTime(0.5)

  --
  cut_scene.Bgm("media/audio/bgm/credits.caf")
  WaitTime(1.5)

  -- title
  --local title_img = SpawnSprite(lang.GetLangStr(LS_TITLE_IMG), 375, 254, 0, 0, 11)
  local title_img = SpawnSprite(lang.GetLangStr(LS_TITLE_IMG), 568, 384, 0, 0, 11)
  cut_scene.ObjSetColor(title_img, { 255, 255, 255, 255 })
  WaitTime(2)
  WaitTimeAndClick(3)
  TransparentTo(title_img, 0, 0.2, true)
  cut_scene.ObjRemove(scene, title_img)

  --

  if game.IsDemo() then

    local txt = SpawnTxt(lang.GetLangStr(LS_DEMO_END), DEFAULT_FONT, DEFAULT_FONT_SIZE, 0, 0, 50)
    cut_scene.ObjSetColor(txt, { 0, 0, 0, 255 })
    ColorTo(txt, { 255, 255, 255, 255 }, 0.1)

    WaitTime(5)

    WaitTimeAndClick(99999)
    cut_scene.ObjRemove(scene, txt)

    finish()
    return

  end

  -- pages
  show_page("media/ending/credits01.png", 0, 0, LS_CREDITS_01, -120, 60);
  show_page("media/ending/credits02.png", 0, 0, LS_CREDITS_02, 80, -80);
  show_page("media/ending/credits03.png", 0, 0, LS_CREDITS_03, -110, -50);
  show_page("media/ending/credits04.png", 0, 0, LS_CREDITS_04, 85, 70);
  show_page("media/ending/credits05.png", 0, 0, LS_CREDITS_05, -140, -10);
  show_page("media/ending/credits06.png", 0, 0, LS_CREDITS_06, 120, 70);
  show_page("media/ending/credits071.png", 0, 0, LS_CREDITS_07, 80, 0);
  show_page("media/ending/credits081.png", 0, 0, LS_CREDITS_08, -80, 0);
  show_page("media/ending/credits072.png", 0, 0, LS_CREDITS_09, 80, 0);
  show_page("media/ending/credits082.png", 0, 0, LS_CREDITS_10, -80, 0);
  show_page("media/ending/credits073.png", -50, 0, LS_CREDITS_11, 80, 0);
  show_page("media/ending/credits083.png", 50, 0, LS_CREDITS_98, -80, 0);
  show_page("media/ending/credits09.png", 0, 0, LS_CREDITS_99, 0, 0, 2, 99999);

  --
  cut_scene.StopBgm(3)
  WaitTime(5)

  --
  cut_scene.Bgm("media/audio/bgm/ending.caf")
  WaitTime(1)
  game.SetBg("media/common/bg0.png");
  game.InkOut()

  local can_skip = game.IsGameComplete()
  local no_txt_skip = false
  local no_ink_in = true
  local use_transition = true
  local txt_display_period = 3

  sword_opening({

    { img = "media/ending/01.png"
      -- ,move = { from = { 0, 0 }, to = { 30, 0 } }
    },
    { translate_id = LS_END_1, x = -100, y = 60 },
    { translate_id = LS_END_2, x = -100, y = 60 },

    { img = "media/ending/02.png"
      -- ,scale = { from = 1, to = 1.15 }
    },
    { translate_id = LS_END_3, x = 60, y = 60 },
    { translate_id = LS_END_4, x = 60, y = 60 },

    { img = "media/ending/03.png"
      ,scale = { from = 0.9, to = 0.8 }
      ,move = { from = { 0, 0 }, to = { 0, -10 } }
    },
    { translate_id = LS_END_5, x = 0, y = 120 },
    { translate_id = LS_END_6, x = 0, y = 120 },

  }, can_skip, no_txt_skip, white_mask_in, no_ink_in, use_transition, txt_display_period)

  -- out
  WaitTime(1)

  finish()
end

function finish()
  if game.IsDemo() then
    game.Reset()
    game.Restart()
    return
  end

  game.ChangeState(GAME_STATE_COMPLETE)
end

function skip()
  finish()
end
