require "cut_scene_common"
require "game_common"
require "lang_str"

function sequence_add(sequence, add_seq)
  for i, v in ipairs(add_seq) do
    table.insert(sequence, v)
  end
end

function start()

  game.InkIn(true)
  cut_scene.StopBgm(0)
  game.PrepareModeBgm()
  WaitTime(0.5)

  game.PlayModeBgm()
  WaitTime(1.5)
  sword_opening_title("media/heavy/title.png", LS_C_HEAVY_0, -110, -20)

  local can_skip = game.IsGameComplete()

  local sequence = {}

  -- skip 1st cutscene if in demo
  if not game.IsDemo() then
    sequence_add(sequence, {

      { img = "media/heavy/01.png",
        move = { from = { 0, 0 }, to = { -30, 0 } },
        scale = { from = 1, to = 1.15 }
      },
      { translate_id = LS_HEAVY_1, x = 90, y = 40 },
      { translate_id = LS_HEAVY_2, x = 90, y = 40 }

    })
  end

  sequence_add(sequence, {

    { img = "media/heavy/02.png",
      move = { from = { 0, 0 }, to = { 30, 0 } },
      scale = { from = 1.15, to = 1 }
    },
    { translate_id = LS_HEAVY_3, x = 0, y = 100 },
    { translate_id = LS_HEAVY_4, x = 0, y = 100 },

    { img = "media/heavy/03.png",
      move = { from = { 0, 0 }, to = { -30, 0 } },
      scale = { from = 1, to = 1.15 }
    },
    { translate_id = LS_HEAVY_5, x = 0, y = 120 },
    { translate_id = LS_HEAVY_6, x = 0, y = 120 }

  })

  sword_opening(sequence, can_skip)

  --
  finish()
end

function finish()
  game.PopState()
end

function skip()
  finish()
end
