require "cut_scene_common"
require "game_common"
require "lang_str"

function show_headphone()
  local headphone_img = SpawnSprite("media/logo/headphone.png", 128, 128, 0, 40, 11)
  local headphone_txt = SpawnTxt(lang.GetLangStr(LS_HEADPHONE), DEFAULT_FONT, DEFAULT_FONT_SIZE, 0, -65, 11)
  cut_scene.ObjSetColor(headphone_img, { 255, 255, 255, 0 })
  cut_scene.ObjSetColor(headphone_txt, { 0, 0, 0, 0 })
  TransparentTo(headphone_img, 255, 1, false)
  ColorTo(headphone_txt, { 255, 255, 255, 255 }, 1)

  WaitTimeAndClick(3)

  TransparentTo(headphone_img, 0, 1, false)
  ColorTo(headphone_txt, { 0, 0, 0, 0 }, 1)
  cut_scene.ObjRemove(scene, headphone_img)
  cut_scene.ObjRemove(scene, headphone_txt)

  WaitTimeAndClick(2)
end

function start()

  game.InkIn(true)
  WaitTime(1)

  if not game.IsDemo() and not game.IsHeadphoneShowed() then
    show_headphone()
    game.SetHeadphoneShowed()
  end
  
  local studio = SpawnTxt("Sunhead Games", DEFAULT_FONT, DEFAULT_FONT_SIZE + 2, 0, 0, 11)

  WaitTime(0.5)
  WaitTimeAndClick(2.5)

  cut_scene.ObjRemove(scene, studio)

  --888
  
  game.OnLogoEnd()

end
