require "cut_scene_common"
require "game_common"
require "lang_str"

function after_sequence()
  WaitTime(1)
  cut_scene.StopBgm(9)
end

function start()

  game.InkIn(true)
  cut_scene.StopBgm(0)

  --

  if game.IsDemo() then
    game.Played()
    finish()
    return
  end

  --

  cut_scene.PrepareBgm("media/audio/bgm/opening.caf")
  WaitTime(0.5)
  cut_scene.Bgm("media/audio/bgm/opening.caf", 0)
  WaitTime(1)
  
  game.SetBg("media/common/bg0.png");

  game.InkOut()

  --

  local can_skip = game.IsGameComplete()
  local no_txt_skip = true

  sword_opening({

    { img = "media/opening/01.png",
      move = { to = { 0, -30 } }
    },
    { translate_id = LS_OP_1, x = -60, y = 100 },
    { translate_id = LS_OP_2, x = -60, y = 100 },

    { img = "media/opening/02.png",
      scale = { from = 1, to = 1.15 }
    },
    { translate_id = LS_OP_3, x = 0, y = 120 },
    { translate_id = LS_OP_4, x = 0, y = 120 },

    { img = "media/opening/03.png",
      move = { to = { 40, 0 } },
      scale = { from = 1.15, to = 1 }
    },
    { translate_id = LS_OP_5, x = -70, y = 0 },
    { translate_id = LS_OP_6, x = -70, y = 0 },

  }, can_skip, no_txt_skip, after_sequence)

  if can_skip then
    WaitTimeAndClick(2.5)
  else
    WaitTime(2.5)
  end

  --
  finish()
end

function finish()
  game.CutScene("media/title/title.lua", GAME_STATE_PLAY)
end

function skip()
  cut_scene.StopBgm(0.1)
  finish()
end
