#define NUM_TEXTURES 2

#ifdef GL_ES
precision highp float;
precision lowp int;
#endif

const int i_zero = 0;
const int i_one = 1;

uniform mat4 model_view_proj_matrix;
uniform mat4 model_view_matrix;

#ifdef GL_ES
uniform lowp int tex_use_coord_idx[NUM_TEXTURES];
#else
uniform int tex_use_coord_idx[NUM_TEXTURES];
#endif

attribute vec4 a_position;
attribute vec4 a_color;
attribute vec2 a_texcoord0;
attribute vec2 a_texcoord1;

varying vec4 v_color;
varying vec2 v_texcoord[NUM_TEXTURES];

void main()
{
  gl_Position = model_view_proj_matrix * a_position;

  v_color = a_color;

  if (tex_use_coord_idx[i_zero] == i_zero)
    v_texcoord[i_zero] = a_texcoord0;
  else if (tex_use_coord_idx[i_zero] == i_one)
    v_texcoord[i_zero] = a_texcoord1;

  if (tex_use_coord_idx[i_one] == i_zero)
    v_texcoord[i_one] = a_texcoord0;
  else if (tex_use_coord_idx[i_one] == i_one)
    v_texcoord[i_one] = a_texcoord1;
}
