#define NUM_TEXTURES 2

#ifdef GL_ES
precision highp float;
precision lowp int;
#endif

const int i_zero = 0;
const int i_one = 1;

#ifdef GL_ES
uniform lowp int tex_use_coord_idx[NUM_TEXTURES];
#else
uniform int tex_use_coord_idx[NUM_TEXTURES];
#endif

uniform sampler2D tex[NUM_TEXTURES];

uniform bool fog_enable;
uniform vec4 fog_color;

varying vec4 v_color;
varying vec2 v_texcoord[NUM_TEXTURES];
varying float v_fog_factor;

void main()
{
  vec4 base_color = v_color;

  if (tex_use_coord_idx[i_zero] >= i_zero)
    base_color *= texture2D(tex[i_zero], v_texcoord[i_zero]);

  if (tex_use_coord_idx[i_one] >= i_zero)
    base_color *= texture2D(tex[i_one], v_texcoord[i_one]);
  
  if (fog_enable)
  {
    gl_FragColor = base_color * v_fog_factor + fog_color * (1.0 - v_fog_factor);
    gl_FragColor.a = base_color.a;
  }
  else
  {
    gl_FragColor = base_color;
  }
}
