boss = nil
firing = false
firing_timer = 0
fired_count = 0

base_speed = 100
base_random_period = 0.65
base_life = 1000

MOVE_PERIOD = 0.5
SPEED_STEP = 10
DEFAULT_CAM_SPEED = 30

function start()
  enemy_lib.ScaleCamIncludeGameplay();

  local setting =
  {
    size = { 32, 32 },
    start_dir = 180,
    move_dir = 0,
    speed = base_speed,
    random_amp = 50,
    random_period = base_random_period,
    life = base_life,

    tail_keep_period = 1,
    tail_fade_period = 2
  }

  boss = enemy_lib.Spawn(setting)
end

function update(delta_time)

  -- firing

  if firing_timer > 0 then
    firing_timer = firing_timer - delta_time
    if firing_timer <= 0 then
      fire_littles()
      firing = false
    end
    --
    return
  end

  if fired_count >= 5 then -- no more fire
    return
  end

  --

  enemy_lib.MoveCamOffset(delta_time * DEFAULT_CAM_SPEED, 0)

  -- check fire

  local curr_life = enemy_lib.GetLife(boss)

  if not firing and (base_life - curr_life) >= 10 then -- hit boss enough (>= 10)

    firing = true
    firing_timer = MOVE_PERIOD
    fired_count = fired_count + 1

    base_speed = base_speed + SPEED_STEP
    enemy_lib.SetSpeed(boss, base_speed)

    base_random_period = base_random_period - 0.05

    if fired_count == 1 then
      enemy_lib.SetRandomMove(boss, 60, base_random_period)
    elseif fired_count == 2 then
      enemy_lib.SetRandomMove(boss, 70, base_random_period)
    elseif fired_count == 3 then
      enemy_lib.SetRandomMove(boss, 80, base_random_period)
    elseif fired_count == 4 then
      enemy_lib.SetRandomMove(boss, 90, base_random_period)
    elseif fired_count == 5 then
      enemy_lib.SetRandomMove(boss, 100, base_random_period)
    end

    local x, y = enemy_lib.GetPos(boss)
    local fire_over_x = x + base_speed * MOVE_PERIOD
    local cam_x, cam_y = enemy_lib.GetCamPos()
    local fire_over_cam_x = fire_over_x + 200

    enemy_lib.MoveCam(fire_over_cam_x, cam_y, MOVE_PERIOD)

    if fired_count >= 5 then -- final fire, boss hp -> 10
      enemy_lib.SetMaxLife(boss, 10)
      enemy_lib.SetLife(boss, 10)
    else
      base_life = curr_life
    end
  end

end

function fire_littles()

  -- local setting =
  -- {
  --   size = { 2, 2 },
  --   start_dir = 170,
  --   move_dir = 20,
  --   speed = 300,
  --   rotate_speed = -30
  -- }
  -- enemy_lib.Spawn(setting)

  -- setting.start_dir = 190
  -- setting.move_dir = 340
  -- setting.rotate_speed = 30

  -- enemy_lib.Spawn(setting)
  
  if fired_count == 1 then
    enemy_lib.SpawnGroup(0)
  elseif fired_count == 2 then
    enemy_lib.SpawnGroup(1)
  elseif fired_count == 3 then
    enemy_lib.SpawnGroup(2)
  elseif fired_count == 4 then
    enemy_lib.SpawnGroup(3)
  elseif fired_count == 5 then
    enemy_lib.SpawnGroup(4)
  end

end