require "cut_scene_common"
require "game_common"
require "lang_str"

function sequence_add(sequence, add_seq)
  for i, v in ipairs(add_seq) do
    table.insert(sequence, v)
  end
end

function start()

  game.InkIn(true)
  cut_scene.StopBgm(0)
  game.PrepareModeBgm()
  WaitTime(0.5)

  game.PlayModeBgm()
  WaitTime(1)
  sword_opening_title("media/sharp/title.png", LS_C_SHARP_0, -80, -70)

  local can_skip = game.IsGameComplete()

  local sequence = {}

  -- skip 1st cutscene if in demo
  if not game.IsDemo() then
    sequence_add(sequence, {

      { img = "media/sharp/01.png",
        move = { from = { 0, 0 }, to = { -25, -20 } }
      },
      { translate_id = LS_SHARP_1, x = -70, y = 90 },
      { translate_id = LS_SHARP_2, x = -70, y = 90 }

    })
  end

  sequence_add(sequence, {

    { img = "media/sharp/02.png",
      scale = { from = 1, to = 1.15 }
    },
    { translate_id = LS_SHARP_3, x = 0, y = 90 },
    { translate_id = LS_SHARP_4, x = 0, y = 90 },

    { img = "media/sharp/03.png",
      move = { to = { -40, 0 } }
    },
    { translate_id = LS_SHARP_5, x = -110, y = -60 },
    { translate_id = LS_SHARP_6, x = -110, y = -60 }

  })

  sword_opening(sequence, can_skip)

  --
  finish()
end

function finish()
  game.PopState()
end

function skip()
  finish()
end
