require "cut_scene_common"
require "game_common"
require "lang_str"

function start()

  WaitTime(0.5)

  txt = SpawnTxt(lang.GetLangStr(LS_T_WOOD_1), DEFAULT_FONT, DEFAULT_FONT_SIZE, 0, -100, 20)
  cut_scene.ObjSetColor(txt, { 0, 0, 0, 0 })
  TransparentTo(txt, 255, 1, false)
  
  anim = SpawnCharAutoSize("media/common/tutorial4.png", "media/common/tutorial4")
  cut_scene.ObjSetScale(anim, 0.5)
  cut_scene.ObjSetPos(anim, 140, 10, 20)

  CharAnim(anim, "press", false, false, 0.2)
  cut_scene.ObjSetColor(anim, { 255, 255, 255, 0 })

  hold_ps = SpawnParticleSystem("media/common/tutorial_ring.xml", "media/common/tutorial_ring.png", 122, 31, 19)
  cut_scene.ObjSetColor(hold_ps, { 255, 255, 255, 0 })

  TransparentTo(anim, 255, 0.5, false)
  TransparentTo(hold_ps, 255, 0.5, false)  

  WaitTime(5)

  TransparentTo(anim, 0, 0.5, false)
  TransparentTo(hold_ps, 0, 0.5, false)
  TransparentTo(txt, 0, 0.5, false)

  --

  WaitTime(1)

  cut_scene.TxtSetMsg(txt, lang.GetLangStr(LS_T_WOOD_2))
  TransparentTo(txt, 255, 1, false)

  WaitTime(4.5)

  TransparentTo(txt, 0, 0.5, false)

  --

  WaitTime(1)

  cut_scene.TxtSetMsg(txt, lang.GetLangStr(LS_T_WOOD_3))
  TransparentTo(txt, 255, 1, false)

  TransparentTo(anim, 255, 0.5, false)
  TransparentTo(hold_ps, 255, 0.5, false)  

  WaitTime(4.5)

  TransparentTo(anim, 0, 0.5, false)
  TransparentTo(hold_ps, 0, 0.5, false)
  TransparentTo(txt, 0, 0.5, false)
  
  --

  WaitTime(1)

  cut_scene.TxtSetMsg(txt, lang.GetLangStr(LS_T_WOOD_4))
  TransparentTo(txt, 255, 1, false)

  WaitTime(4.5)

  TransparentTo(txt, 0, 0.5)

  cut_scene.ObjRemove(scene, anim)
  cut_scene.ObjRemove(scene, hold_ps)

  cut_scene.ReleaseTexture("media/common/tutorial4.png")
  cut_scene.ReleaseTexture("media/common/tutorial_ring.png")

end
