require "cut_scene_common"
require "game_common"
require "lang_str"

function sequence_add(sequence, add_seq)
  for i, v in ipairs(add_seq) do
    table.insert(sequence, v)
  end
end

function start()

  game.InkIn(true)
  cut_scene.StopBgm(0)
  game.PrepareModeBgm()
  WaitTime(0.5)

  game.PlayModeBgm()
  WaitTime(1.5)
  sword_opening_title("media/wood/title.png", LS_C_WOOD_0, 0, -100, 20)

  local can_skip = game.IsGameComplete()

  local sequence = {}

  -- skip 1st cutscene if in demo
  if not game.IsDemo() then
    sequence_add(sequence, {

      { img = "media/wood/01.png",
        move = { from = { 20, 0 }, to = { -20, 0 } }
      },
      { translate_id = LS_WOOD_1, x = 0, y = -70 },
      { translate_id = LS_WOOD_2, x = 0, y = -70 }

    })
  end

  sequence_add(sequence, {

    { img = "media/wood/02.png",
      move = { from = { 0, 0 }, to = { 0, -30 } }
    },
    { translate_id = LS_WOOD_3, x = -30, y = 100 },
    { translate_id = LS_WOOD_4, x = -30, y = 100 },

    { img = "media/wood/03.png",
      move = { from = { 0, 0 }, to = { 0, 30 } },
      scale = { from = 1, to = 1.2 }
    },
    { translate_id = LS_WOOD_5, x = -60, y = 90 },
    { translate_id = LS_WOOD_6, x = -60, y = 90 }

  })

  sword_opening(sequence, can_skip)

  --
  finish()
end

function finish()
  game.PopState()
end

function skip()
  finish()
end
